begin
  require 'bot/controlbot'
rescue LoadError
  require 'mod/bot/controlbot'
end

class Controlbotmod 

   def initialize
      @bot = ControlBot.new
      @MAX = 400
   end

	def instantRelease?
		false
	end
	
	def data(sock,output,mods)
		@sock = sock
	end

	def GeneralMessage(msg)
	end

	def ModuleMessage(msg)
	end

	def IRCMessage(message)
      begin
         if message.getMethod != 'PRIVMSG' 
            return
         end
         response = @bot.getResponse(message.getMessage)
         if response =~ /\n/
            response.each { |line|
               @sock.irc_puts("PRIVMSG #{message.getSendTarget} :#{line}")
            }
            return
         end
         if response.size < @MAX and not response.empty?
			   @sock.irc_puts("PRIVMSG #{message.getSendTarget} :#{response}")
         elsif response.size > @MAX
            r1 = response
            count = 0
            times = 0
            while not r1.empty? and times < 3
               times += 1
               begin
                  msg = response[count..@MAX+count]
               rescue
                  msg = response[count..-1]
               end
               puts "msg==", msg, "|"
               @sock.irc_puts("PRIVMSG #{message.getSendTarget} :#{msg}")
               r1 = response[(count+@MAX+1)..-1]
               count = count + @MAX + 1
            end
         end
		rescue
			puts "Eep! Controlbotmod error: #{$!}"
		end
	end

	def getModuleName
		return 'Controlbotmod'
	end

	def getModuleAuthor
		return 'trane'
	end

	def getModuleVersion
		return 0.2
	end

	def getModuleDescription
		return 'Agent controller.'
	end
 end

$modules.loadModule(Controlbotmod.new)
